## safeint 3.0.28a%2Bdfsg

=== debian/changelog ===
safeint (3.0.28a+dfsg-4) unstable; urgency=medium

  * Add Multi-Arch: foreign
  * Standards-Version: 4.7.0 (no changes required)

 -- Dylan Aïssi <daissi@debian.org>  Tue, 03 Dec 2024 10:21:25 +0100

safeint (3.0.28a+dfsg-3) unstable; urgency=medium

  * Disable broken tests with GCC 13 (Closes: #1042152)

 -- Dylan Aïssi <daissi@debian.org>  Fri, 10 Nov 2023 17:08:35 +0100

safeint (3.0.28a+dfsg-2) unstable; urgency=medium

  * Source only upload to unstable

 -- Dylan Aïssi <daissi@debian.org>  Thu, 25 May 2023 15:23:25 +0200

safeint (3.0.28a+dfsg-1) experimental; urgency=medium

  * Initial release

 -- Dylan Aïssi <daissi@debian.org>  Wed, 17 May 2023 11:17:11 +0200

## safeint 3.0.28a+dfsg

=== Test/GccTest/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(SafeInt VERSION 3.0.26)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED True)

# Runtime tests are:
# - default
# - without built-in 128-bit support
# - without intrinsics

# Compile time tests are:
# - default C++11
# - C++14
# - TODO - consider adding in 17, 20 just to see if anything breaks
# - compile without exceptions

# Supported compilers:
# - Microsoft
# - clang
# - gcc
# - Intel (not regularly tested)
# other compilers on a best effort

# test for g++
find_program(GCC_PLUS_PLUS "g++")

if(NOT GCC_PLUS_PLUS)
    message(STATUS "Skipping g++ testing")
else()
    message(STATUS "g++ available, configuring g++ tests")
    set(CMAKE_CXX_COMPILER ${GCC_PLUS_PLUS})
    # the standard level is already at C++11, which is what we need for runtime tests
    add_compile_options(-O3 -ftrapv)

    # Note - -fsanitize=undefined isn't currently working with g++ and cmake
    # if you go build from the old makefile in Test/GccTest, it does work
    # -fsanitize-trap=undefined does work in clang++, so we have coverage there

    # This will test whatever the mainline code can do, typically using int128
    add_executable(SafeIntTest_gcc 
        ../AddVerify.cpp 
        ../AddTestCase.cpp
        ../CastVerify.cpp 
        ../DivVerify.cpp 
        ../DivTestCase.cpp
        ../IncDecVerify.cpp 
        ../ModVerify.cpp 
        ../MultVerify.cpp 
        ../MultTestCase.cpp
        ../SubVerify.cpp 
        ../SubTestCase.cpp
        ../TestMain.cpp
        ../TestMain.h
        ../../SafeInt.hpp
    )

    # Forces use of the older, less efficient code that can't use either int128 or intrinsics
    add_executable(SafeIntTest_gcc_NoIntrinsic
        ../AddVerify.cpp 
        ../AddTestCase.cpp
        ../CastVerify.cpp 
        ../DivVerify.cpp 
        ../DivTestCase.cpp
        ../IncDecVerify.cpp 
        ../ModVerify.cpp 
        ../MultVerify.cpp 
        ../MultTestCase.cpp
        ../SubVerify.cpp 
        ../SubTestCase.cpp
        ../TestMain.cpp
        ../TestMain.h
        ../../SafeInt.hpp
    )

    target_compile_definitions(SafeIntTest_gcc_NoIntrinsic PUBLIC "SAFEINT_USE_INTRINSICS=0" "SAFEINT_HAS_INT128=0")

    # Forces use of either intrinsics or the older code
    add_executable(SafeIntTest_gcc_NoInt128
        ../AddVerify.cpp 
        ../AddTestCase.cpp
        ../CastVerify.cpp 
        ../DivVerify.cpp 
        ../DivTestCase.cpp
        ../IncDecVerify.cpp 
        ../ModVerify.cpp 
        ../MultVerify.cpp 
        ../MultTestCase.cpp
        ../SubVerify.cpp 
        ../SubTestCase.cpp
        ../TestMain.cpp
        ../TestMain.h
        ../../SafeInt.hpp
    )

    target_compile_definitions(SafeIntTest_gcc_NoInt128 PUBLIC "SAFEINT_HAS_INT128=0")

    # compilation tests, these are good if they just build
    add_executable(CompileTest_gcc
        ../CompileTest.cpp
        ../ConstExpr.cpp 
        ../CleanCompile.cpp
        ../../SafeInt.hpp
    )

    target_compile_options(CompileTest_gcc PUBLIC -Wall)

    add_executable(CompileTest_gcc17
        ../CompileTest.cpp
        ../ConstExpr.cpp 
        ../CleanCompile.cpp
        ../../SafeInt.hpp
    )

    target_compile_options(CompileTest_gcc17 PUBLIC -Wall -std=c++17)

    add_executable(CompileTest_gcc14
        ../CompileTest.cpp
        ../ConstExpr.cpp 
        ../CleanCompile.cpp
        ../../SafeInt.hpp
    )

    target_compile_options(CompileTest_gcc14 PUBLIC -Wall -std=c++14)

    add_executable(CompileTest_gcc14_NoEH
        ../CompileTest.cpp
        ../ConstExpr.cpp 
        ../CleanCompile.cpp
        ../../SafeInt.hpp
    )

    target_compile_options(CompileTest_gcc14_NoEH PUBLIC -Wall -std=c++14 -fno-exceptions)

    add_executable(CompileTest_gcc98
    ../CompileTest.cpp
    ../ConstExpr.cpp 
    ../CleanCompile.cpp
    ../../SafeInt.hpp
    )

    target_compile_options(CompileTest_gcc98 PUBLIC -D SAFEINT_USE_CPLUSCPLUS_98 -Wall -std=c++98 -fno-exceptions)

    add_executable(safe_math_test_gcc
    ../c_safe_math/safe_math_test.c
    ../c_safe_math/safe_math_test.h
    ../c_safe_math/safe_math_test_add.cpp
    ../c_safe_math/safe_math_test_div.cpp
    ../c_safe_math/safe_math_test_mult.cpp
    ../c_safe_math/safe_math_test_sub.cpp
    ../AddTestCase.cpp
    ../DivTestCase.cpp
    ../MultTestCase.cpp
    ../SubTestCase.cpp
    )

    target_compile_definitions(safe_math_test_gcc PUBLIC)
    target_compile_options(safe_math_test_gcc PUBLIC)

    add_executable(safe_math_compile_gcc
    ../c_safe_math/safe_math_compile.c
    ../c_safe_math/compile_test.c
    ../../safe_math.h
    ../../safe_math_impl.h
)

target_compile_options(safe_math_compile_gcc PUBLIC -Wall)


endif()


enable_testing()

if(GCC_PLUS_PLUS)
    add_test(NAME SafeIntTest_gcc COMMAND SafeIntTest_gcc)
    add_test(NAME SafeIntTest_gcc_NoIntrinsic COMMAND SafeIntTest_gcc_NoIntrinsic)
    add_test(NAME SafeIntTest_gcc_NoInt128 COMMAND SafeIntTest_gcc_NoInt128)
    add_test(NAME safe_math_test_gcc COMMAND safe_math_test_gcc)

    set_tests_properties(SafeIntTest_gcc 
                        SafeIntTest_gcc_NoIntrinsic 
                        SafeIntTest_gcc_NoInt128 
                        safe_math_test_gcc
                        PROPERTIES FAIL_REGULAR_EXPRESSION "Error")
endif()

=== Test/MsvcTest/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(SafeInt VERSION 3.0.26)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED True)

# Runtime tests are:
# - default
# - without built-in 128-bit support
# - without intrinsics

# Compile time tests are:
# - default C++11
# - C++14
# - TODO - consider adding in 17, 20 just to see if anything breaks
# - compile without exceptions

# Supported compilers:
# - Microsoft
# - clang
# - gcc
# - Intel (not regularly tested)
# other compilers on a best effort

# test for g++
find_program(MSVC_CL "cl.exe")

if(NOT MSVC_CL)
    message(STATUS "Skipping MSVC testing")
else()
    message(STATUS "MSVC available, configuring MSVC tests")
    set(CMAKE_CXX_COMPILER ${MSVC_CL})

    # the standard level is already at C++11, which is what we need for runtime tests
    add_compile_options(/Wall /wd4710 /wd4711)

    # This will test whatever the mainline code can do, typically using int128
    add_executable(SafeIntTest_msvc 
        ../AddVerify.cpp 
        ../AddTestCase.cpp
        ../CastVerify.cpp 
        ../DivVerify.cpp 
        ../DivTestCase.cpp
        ../IncDecVerify.cpp 
        ../ModVerify.cpp 
        ../MultVerify.cpp 
        ../MultTestCase.cpp
        ../SubVerify.cpp 
        ../SubTestCase.cpp
        ../TestMain.cpp
        ../TestMain.h
        ../../SafeInt.hpp
    )
    
        # Forces use of the older, less efficient code that can't use either int128 or intrinsics
        add_executable(SafeIntTest_msvc_NoIntrinsic
        ../AddVerify.cpp 
        ../AddTestCase.cpp
        ../CastVerify.cpp 
        ../DivVerify.cpp 
        ../DivTestCase.cpp
        ../IncDecVerify.cpp 
        ../ModVerify.cpp 
        ../MultVerify.cpp 
        ../MultTestCase.cpp
        ../SubVerify.cpp 
        ../SubTestCase.cpp
        ../TestMain.cpp
        ../TestMain.h
        ../../SafeInt.hpp
    )

    target_compile_definitions(SafeIntTest_msvc_NoIntrinsic PUBLIC "SAFEINT_USE_INTRINSICS=0" "SAFEINT_HAS_INT128=0")

    # compilation tests, these are good if they just build
    add_executable(CompileTest_msvc
    ../CompileTest.cpp
    ../ConstExpr.cpp 
    ../CleanCompile.cpp
    ../../SafeInt.hpp
    )

    target_compile_options(CompileTest_msvc PUBLIC /wd4711 /wd4710)

    add_executable(CompileTest_msvc14
    ../CompileTest.cpp
    ../ConstExpr.cpp 
    ../CleanCompile.cpp
    ../../SafeInt.hpp
    )

    target_compile_options(CompileTest_msvc14 PUBLIC /std:c++14 /wd4711)

    add_executable(CompileTest_msvc17
    ../CompileTest.cpp
    ../ConstExpr.cpp 
    ../CleanCompile.cpp
    ../../SafeInt.hpp
    )

    target_compile_options(CompileTest_msvc17 PUBLIC /std:c++17)

    # compilation tests, these are good if they just build
    add_executable(CompileTest_msvc_noexcept
    ../CompileTest.cpp
    ../ConstExpr.cpp 
    ../CleanCompile.cpp
    ../../SafeInt.hpp
    )

    target_compile_options(CompileTest_msvc_noexcept PUBLIC /wd4711 /wd4710 /EHsc)

    add_executable(safe_math_test_msvc
    ../c_safe_math/safe_math_test.c
    ../c_safe_math/safe_math_test.h
    ../c_safe_math/safe_math_test_add.cpp
    ../c_safe_math/safe_math_test_div.cpp
    ../c_safe_math/safe_math_test_mult.cpp
    ../c_safe_math/safe_math_test_sub.cpp
    ../c_safe_math/compile_test.c
    ../AddTestCase.cpp
    ../DivTestCase.cpp
    ../MultTestCase.cpp
    ../SubTestCase.cpp
    )

    target_compile_definitions(safe_math_test_msvc PUBLIC)
    target_compile_options(safe_math_test_msvc PUBLIC /wd4464)

    add_executable(safe_math_compile_msvc
    ../c_safe_math/safe_math_compile.c
    ../c_safe_math/compile_test.c
    ../../safe_math.h
    ../../safe_math_impl.h
    )

    target_compile_options(safe_math_compile_msvc PUBLIC -Wall /wd4464)

endif()

enable_testing()

if(MSVC_CL)
    add_test(NAME SafeIntTest_msvc COMMAND SafeIntTest_msvc)
    add_test(NAME SafeIntTest_msvc_NoIntrinsic COMMAND SafeIntTest_msvc_NoIntrinsic)
    add_test(NAME safe_math_test_msvc COMMAND safe_math_test_msvc)

    set_tests_properties(SafeIntTest_msvc 
                        SafeIntTest_msvc_NoIntrinsic 
                        safe_math_test_msvc
                        PROPERTIES FAIL_REGULAR_EXPRESSION "Error")
endif()

=== debian/changelog ===
safeint (3.0.28a+dfsg-5) unstable; urgency=medium

  * Improve d/watch
  * Update debian/copyright
  * Add debian/upstream/metadata
  * Add debian/salsa-ci.yml
  * Standards-Version: 4.7.2 (no changes required)
  * Update DEP3 header of Fix_gcc13.patch

 -- Dylan Aïssi <daissi@debian.org>  Wed, 13 Aug 2025 08:11:29 +0200

=== debian/control ===
Source: safeint
Section: libdevel
Priority: optional
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Dylan Aïssi <daissi@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/deeplearning-team/safeint
Vcs-Git: https://salsa.debian.org/deeplearning-team/safeint.git
Homepage: https://github.com/dcleblanc/SafeInt

Package: libsafeint-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: class library for C++ that manages integer overflows
 SafeInt is a class library for C++ that manages integer overflows. It also
 includes a C library that checks casting, multiplication, division, addition
 and subtraction for all combinations of signed and unsigned 32-bit and 64-bit
 integers.

=== debian/watch ===
version=4
opts="uversionmangle=s/3.2/3.0.2/,repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g" \
 https://github.com/dcleblanc/SafeInt/tags .*/v?(\d.*)@ARCHIVE_EXT@
